'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var makeRelative = require('./make-relative');

var isObject = function isObject(obj) {
	return obj === Object(obj);
};

var walkObject = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(obj, iteratee) {
		var ignoreKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
		var prop;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.t0 = _regenerator2.default.keys(obj);

					case 1:
						if ((_context.t1 = _context.t0()).done) {
							_context.next = 21;
							break;
						}

						prop = _context.t1.value;

						if (!(!obj[prop] || typeof obj[prop].then === 'function' || ignoreKeys.indexOf(prop) !== -1)) {
							_context.next = 5;
							break;
						}

						return _context.abrupt('continue', 1);

					case 5:
						if (!Array.isArray(obj[prop])) {
							_context.next = 10;
							break;
						}

						_context.next = 8;
						return walkArray(obj[prop], iteratee, ignoreKeys, true);

					case 8:
						_context.next = 19;
						break;

					case 10:
						if (!isObject(obj[prop])) {
							_context.next = 16;
							break;
						}

						_context.next = 13;
						return walkObject(obj[prop], iteratee, ignoreKeys);

					case 13:
						obj[prop] = _context.sent;
						_context.next = 19;
						break;

					case 16:
						_context.next = 18;
						return iteratee(obj[prop]);

					case 18:
						obj[prop] = _context.sent;

					case 19:
						_context.next = 1;
						break;

					case 21:
						return _context.abrupt('return', obj);

					case 22:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function walkObject(_x, _x2) {
		return _ref.apply(this, arguments);
	};
}();

var walkArray = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(arr, iteratee) {
		var ignoreKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
		var tags = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
		return _regenerator2.default.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						arr.forEach(function () {
							var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(item, idx, a) {
								return _regenerator2.default.wrap(function _callee2$(_context2) {
									while (1) {
										switch (_context2.prev = _context2.next) {
											case 0:
												if (!(typeof item.then === 'function')) {
													_context2.next = 2;
													break;
												}

												return _context2.abrupt('return');

											case 2:
												if (!Array.isArray(item)) {
													_context2.next = 8;
													break;
												}

												_context2.next = 5;
												return walkArray(item, iteratee, ignoreKeys);

											case 5:
												a[idx] = _context2.sent;
												_context2.next = 17;
												break;

											case 8:
												if (!isObject(item)) {
													_context2.next = 14;
													break;
												}

												_context2.next = 11;
												return walkObject(item, iteratee, ignoreKeys);

											case 11:
												a[idx] = _context2.sent;
												_context2.next = 17;
												break;

											case 14:
												_context2.next = 16;
												return iteratee(item);

											case 16:
												a[idx] = _context2.sent;

											case 17:
											case 'end':
												return _context2.stop();
										}
									}
								}, _callee2, undefined);
							}));

							return function (_x8, _x9, _x10) {
								return _ref3.apply(this, arguments);
							};
						}());

					case 1:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, undefined);
	}));

	return function walkArray(_x4, _x5) {
		return _ref2.apply(this, arguments);
	};
}();

exports.onCreateNode = function () {
	var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(_ref5, options) {
		var node = _ref5.node,
		    getNode = _ref5.getNode;
		var commonProps, nodeAbsPath, iteratee;
		return _regenerator2.default.wrap(function _callee5$(_context5) {
			while (1) {
				switch (_context5.prev = _context5.next) {
					case 0:
						commonProps = ['id', '_PARENT', 'parent', 'children', 'internal'];
						nodeAbsPath = void 0;

						iteratee = function () {
							var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(val) {
								return _regenerator2.default.wrap(function _callee4$(_context4) {
									while (1) {
										switch (_context4.prev = _context4.next) {
											case 0:
												_context4.next = 2;
												return makeRelative(nodeAbsPath, val, options);

											case 2:
												return _context4.abrupt('return', _context4.sent);

											case 3:
											case 'end':
												return _context4.stop();
										}
									}
								}, _callee4, undefined);
							}));

							return function iteratee(_x13) {
								return _ref6.apply(this, arguments);
							};
						}();

						if (!(node.internal.type === 'MarkdownRemark')) {
							_context5.next = 10;
							break;
						}

						nodeAbsPath = node.fileAbsolutePath;

						if (!((0, _typeof3.default)(node.frontmatter) === 'object')) {
							_context5.next = 8;
							break;
						}

						_context5.next = 8;
						return walkObject(node.frontmatter, iteratee, commonProps);

					case 8:
						_context5.next = 14;
						break;

					case 10:
						if (!/^\w+Yaml$/.test(node.internal.type)) {
							_context5.next = 14;
							break;
						}

						nodeAbsPath = getNode(node.parent).absolutePath;

						_context5.next = 14;
						return walkObject(node, iteratee, commonProps);

					case 14:
					case 'end':
						return _context5.stop();
				}
			}
		}, _callee5, undefined);
	}));

	return function (_x11, _x12) {
		return _ref4.apply(this, arguments);
	};
}();
//# sourceMappingURL=gatsby-node.js.map